*** Settings ***
Library     RPA.Windows
Library     String
Library     Collections
Library     RPA.Robocorp.WorkItems


*** Tasks ***
Calculate Sum
    Set Task Variables From Work Item

    ${result}=    Calculate Sum    ${a}    ${b}

    Create Output Work Item
    Set Work Item Variable    result    ${result}
    Save Work Item


*** Keywords ***

Calculate Sum
    [Documentation]    Calculate sum of two integer values using Calculator
    [Arguments]    ${a}    ${b}
    Start Calculator
    Input Number To Calc    ${a}
    Click If Available    Calculator - Plus
    Input Number To Calc    ${b}
    Click If Available    Calculator - Equals
    ${result}=    Get Result From Calc
    Close Window    name:Calculator
    [Return]    ${result}

Start Calculator
    Windows Search    Calculator

Input Number To Calc
    [Documentation]    Splits the input number into digits and clicks Calculator buttons
    [Arguments]    ${number}
    Control Window    Calculator
    ${cleared}=    Click If Available    Calculator - CE
    IF    not $cleared    Click If Available    Calculator - C
    ${digits}=    Convert To String    ${number}
    ${digit_list}=    Split String To Characters    ${digits}
    FOR    ${digit}    IN    @{digit_list}
        Click    Calculator - ${digit}
    END

Click If Available
    [Documentation]    Clicks Windows locator if available
    [Arguments]    ${locator}
    TRY
        Click    ${locator}
        RETURN    ${TRUE}
    EXCEPT
        RETURN    ${FALSE}
    END

Get Result From Calc
    [Documentation]    Reads Calculator's calculation result
    ${result}=    Get Attribute    Calculator - IdCalculatorResults    Name
    ${total}=    Remove String    ${result}    Display is${SPACE}
    ${total}=    Convert To Integer    ${total}
    RETURN    ${total}
